<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:n="http://www.minefi.gouv.fr/cp/helios/pes_v2/erar/r0/restit" xmlns="http://www.minefi.gouv.fr/cp/helios/pes_v2/erar/r0/restit" version="2.0">
    <xsl:param name="DEB_ID_TIERS"/>
    <xsl:param name="DEB_NOM"/>
    <xsl:param name="DEB_PRENOM"/>
    <xsl:param name="DEB_ADR1"/>
    <xsl:param name="DEB_ADR2"/>
    <xsl:param name="DEB_ADR3"/>
    <xsl:param name="DEB_CP"/>
    <xsl:param name="DEB_VILLE"/>
    <xsl:param name="somme"/>
    <xsl:param name="rar_frais"/>
    <xsl:param name="rar_princ"/>
    
    <xsl:output encoding="UTF-8" exclude-result-prefixes="xsl" method="xml" indent="yes"/>

    <xsl:template match="/">
        <PosteComptable>
            <Piece>
                <LigneERAR>
                    <xsl:if test="string-length($somme) &gt; 0">
                        <xsl:attribute name="RarTotal"><xsl:value-of select="$somme"/></xsl:attribute>
                    </xsl:if>
                    <xsl:if test="string-length($rar_frais) &gt; 0">
                        <xsl:attribute name="RarFrais"><xsl:value-of select="$rar_frais"/></xsl:attribute>
                    </xsl:if>
                    <xsl:if test="string-length($rar_princ) &gt; 0">
                        <xsl:attribute name="RarPrincipal"><xsl:value-of select="$rar_princ"/></xsl:attribute>
                    </xsl:if>
                    <Debiteur>
                            <xsl:if test="string-length($DEB_ID_TIERS) &gt; 0">
                                <xsl:attribute name="IdTiers"><xsl:value-of select="$DEB_ID_TIERS"/></xsl:attribute>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_NOM) &gt; 0">
                                <xsl:attribute name="Nom"><xsl:value-of select="$DEB_NOM"/></xsl:attribute>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_PRENOM) &gt; 0">
                                <xsl:attribute name="Prenom"><xsl:value-of select="$DEB_PRENOM"/></xsl:attribute>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_ADR1) &gt; 0">
                                <xsl:attribute name="Adr1"><xsl:value-of select="$DEB_ADR1"/></xsl:attribute>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_ADR2) &gt; 0">
                                <xsl:attribute name="Adr2"><xsl:value-of select="$DEB_ADR2"/></xsl:attribute>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_ADR3) &gt; 0">
                                <xsl:attribute name="Adr3"><xsl:value-of select="$DEB_ADR3"/></xsl:attribute>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_CP) &gt; 0">
                                <xsl:attribute name="CP"><xsl:value-of select="$DEB_CP"/></xsl:attribute>
                            </xsl:if>
                            <xsl:if test="string-length($DEB_VILLE) &gt; 0">
                                <xsl:attribute name="Ville"><xsl:value-of select="$DEB_VILLE"/></xsl:attribute>
                            </xsl:if>
                    </Debiteur>
                </LigneERAR>
            </Piece>
        </PosteComptable>
    </xsl:template>
</xsl:stylesheet>
