<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
]>

<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:n="http://www.minefi.gouv.fr/cp/helios/pes_v2/erar/r0/restit"
 xmlns:xs="http://www.w3.org/2001/XMLSchema"
 xmlns:added="http://projets.admisource.gouv.fr/xemelios/namespaces#added"
 xmlns:ano="http://projets.admisource.gouv.fr/xemelios/namespaces#anomally"
 version="2.0">
    
 <xsl:output standalone="yes" method="xml" indent="yes"/>

 <xsl:output encoding="##output-encoding##"/>
 <xsl:output version="##xml-version##"/>
 
 <xsl:param name="language" select="'fr'"/>
 
 <xsl:variable name="nomenclature">
  <CatTiers>
   <desc code="1">Personne physique</desc>
   <desc code="2">Personne morale de droit priv</desc>
   <desc code="3">Personne morale de droit public</desc>
   <desc code="4">Inconnu</desc>
  </CatTiers>
  <NatJur>
   <desc code="0">Inconnue</desc>
   <desc code="1">Particulier</desc>
   <desc code="2">Artisan comm. agric.</desc>
   <desc code="3">Socit</desc>
   <desc code="4">Caisse assur. mal.</desc>
   <desc code="5">Caisse complm.</desc>
   <desc code="6">Association</desc>
   <desc code="7">tat ou org. tat</desc>
   <desc code="8">Etab. public nat.</desc>
   <desc code="9">Collect. territor.</desc>
   <desc code="10">Autres Etab. Pub, Etat tr., ambassade</desc>
   <desc code="11">Caisse alloc. fam.</desc>
  </NatJur>
  <EtatEtape>
   <desc code="0">Rien</desc>
   <desc code="1">Courante</desc>
   <desc code="3">Passe</desc>
   <desc code="4">Possible</desc>
   <desc code="5">A faire</desc>
   <desc code="6">Annule</desc>
  </EtatEtape>
  <ValiditeEtape>
   <desc code="0">Rien</desc>
   <desc code="1">Proposition validation</desc>
   <desc code="2">Valide</desc>
   <desc code="3">Aucun</desc>
  </ValiditeEtape>
  <OrigineEtape>
   <desc code="1">Automate</desc>
   <desc code="2">Validation</desc>
   <desc code="3">Action individuelle</desc>
  </OrigineEtape>
  <CodeActu>
      <desc code="1">Demande transmise</desc>
      <desc code="2">NPAI</desc>
      <desc code="3">Dcd</desc>
      <desc code="4">Opposition a poursuite</desc>
      <desc code="5">Reconnaissance de dette</desc>
      <desc code="6">Notifi</desc>
      <desc code="7">Non reclam</desc>
      <desc code="8">Envoy  huissier</desc>
      <desc code="9">Positive</desc>
      <desc code="10">Positive diffre</desc>
      <desc code="11">Ngative</desc>
      <desc code="12">Envoi pour accord</desc>
      <desc code="13">Transmission caf</desc>
      <desc code="14">Remise huissier</desc>
      <desc code="15">Denonciation</desc>
      <desc code="16">Envoi certif non contestation</desc>
      <desc code="17">Contestation</desc>
      <desc code="18">Non contestation</desc>
      <desc code="19">Positive sans provision</desc>
      <desc code="20">Remise tribunal instance</desc>
      <desc code="21">Tentative conciliation</desc>
      <desc code="22">Saisie refuse</desc>
      <desc code="23">Saisie accepte</desc>
      <desc code="24">Saisie excute</desc>
      <desc code="25">PV perquisition</desc>
      <desc code="26">Saisie interrompue</desc>
      <desc code="27">PV carence</desc>
      <desc code="28">PV recherche</desc>
      <desc code="29">Envoi avis tpg</desc>
      <desc code="30">Autorisation tpg refuse</desc>
      <desc code="31">Autorisation tpg accorde</desc>
      <desc code="32">Vente execute</desc>
      <desc code="33">Produit insuffisant</desc>
      <desc code="34">Signification chec</desc>
      <desc code="35">Accord caf</desc>
      <desc code="36">Mandatement office</desc>
      <desc code="37">Inscription office</desc>
      <desc code="38">Rglement et liquidation judiciaire</desc>
      <desc code="39">Surendettement</desc>
      <desc code="40">Demande renseign. ngative</desc>
      <desc code="41">Expulsion refuse</desc>
      <desc code="42">Dossier contrainte exterieure refuse TPG</desc>
      <desc code="43">Certificat irrecouvrabilite</desc>
      <desc code="44">Insuffisance actif rjlj</desc>
      <desc code="45">Dossier succession negatif</desc>
      <desc code="46">Refus par le reprsentant de l tat du mandatement office</desc>
      <desc code="47">Action civile refuse par le juge</desc>
      <desc code="48">Sold</desc>
      <desc code="49">Commandement signifi  parquet</desc>
      <desc code="50">Procdure post mise en demeure</desc>
      <desc code="51">Reprise plan de recouvrement aprs saisie</desc>
      <desc code="52">Saisie annule</desc>
      <desc code="53">Tentative de saisie</desc>
      <desc code="54">Procs verbal opposition jonction</desc>
      <desc code="55">Acte retourn , destinataire non inform</desc>
      <desc code="56">Pappel P767 dans le cas de poursuites extrieures</desc>
      <desc code="57">Poursuite extrieure solde</desc>
      <desc code="58">Divers</desc>
      <desc code="59">Non notifi</desc>
      <desc code="60">Attestation liquidateur</desc>
      <desc code="61">Attente visa ordonnateur</desc>
      <desc code="62">Attente visa TPG</desc>
      <desc code="63">Commandement refus expressment</desc>
      <desc code="64">Commandement refus tacitement</desc>
      <desc code="65">AP saisie/OTD diffre</desc>
      <desc code="66">AP saisie/OTD refuse expressment (toutes saisies)</desc>
      <desc code="67">AP saisie/OTD refuse tacitement (toutes saisies)</desc>
      <desc code="68">Vente - autorisation refuse</desc>
      <desc code="69">AP accorde pour toutes saisies/OTD</desc>
      <desc code="70">Refus Ordonnateur pour Saisie/OTD Remun. et SV</desc>
      <desc code="71">Refus Ordonnateur pour autres que Saisie/OTD Remun.</desc>
      <desc code="72">Refus Ordonnateur pour autre que SV</desc>
      <desc code="73">Refus Ordonnateur pour SV</desc>
      <desc code="74">Refus Ordonnateur pour Saisie/OTD Remun.</desc>
      <desc code="75">Refus Ordonnateur pour autre que Saisie/OTD Remun. et SV</desc>
      <desc code="76">Commandement accord</desc>
      <desc code="77">Saisie accorde (migration)</desc>
      <desc code="78">Saisie refusee (migration)</desc>
      <desc code="79">Vente demande autorisation</desc>
      <desc code="80">Vente autorisation accorde</desc>
      <desc code="81">Vente autorisation refusee</desc>
      <desc code="82">Commandement annul</desc>
      <desc code="83">Acte de poursuite annul</desc>
      <desc code="84">Demande renseign. Envoye</desc>
      <desc code="85">Demande renseign. Positive</desc>
      <desc code="86">Dnonciation au tiers dbiteur</desc>
      <desc code="87">Saisie accepte par le dbiteur</desc>
      <desc code="88">Tentative de conciliation suite SR (chancier)</desc>
      <desc code="89">SR positive</desc>
      <desc code="90">SR ngative</desc>
      <desc code="91">Cause interruptive de prescription</desc>
      <desc code="92">Attente de fonds</desc>
      <desc code="93">Cantonnement</desc>
      <desc code="94">Tiers dtenteur saisi par un autre crancier</desc>
      <desc code="95">Ngative / Echec</desc>
      <desc code="96">Procdure interrompue</desc>
  </CodeActu>
  <TypTiers>
   <desc code="1">Dbiteur principal</desc>
   <desc code="2">Dbiteur appliquant des rgles particulires et pouvant assumer la totalit des frais de sjour</desc>
   <desc code="3">Dbiteur solidaire</desc>
   <desc code="4">Co-dbiteur</desc>
   <desc code="5">Employeur</desc>
   <desc code="6">Malade</desc>
   <desc code="7">Assur</desc>
  </TypTiers>
  <NatIdTiers>
   <desc code="1">Siret</desc>
   <desc code="2">Siren</desc>
   <desc code="3">Finess</desc>
   <desc code="4">NIR</desc>
  </NatIdTiers>
  <TypeRef>
   <desc code="00">Bordereau</desc>
   <desc code="01">Rle</desc>
  </TypeRef>
  <TypAdr>
   <desc code="0">Non prcis</desc>
   <desc code="1">Principale</desc>
   <desc code="2">Secondaire</desc>
  </TypAdr>
  <CodeEtape>
      <desc code="1">Avis somme  payer</desc>
      <desc code="2">Lettre de rappel</desc>
      <desc code="3">Mise en demeurre</desc>
      <desc code="4">Autorisation cmdt</desc>
      <desc code="5">Cdt sans frais</desc>
      <desc code="6">Autorisation saisie</desc>
      <desc code="7">Saisie attribution</desc>
      <desc code="8">Saisie attribution CAF</desc>
      <desc code="9">Saisie rmunration</desc>
      <desc code="10">Saisie vente</desc>
      <desc code="11">Vente</desc>
      <desc code="12">Etat Poursuite extrieure</desc>
      <desc code="14">Saisie des coffres-forts</desc>
      <desc code="15">Saisie vtm</desc>
      <desc code="16">Saisie vmp</desc>
      <desc code="17">Avis avant tat des poursuites extrieures</desc>
      <desc code="18">cdt avec frais</desc>
      <desc code="19">cdt produit hospitalier sans frais</desc>
      <desc code="20">cdt produit hospitalier avec frais</desc>
      <desc code="21">Lettre rappel produit hospitalier</desc>
      <desc code="22">Phase comminatoire</desc>
      <desc code="23">OTD Employeur</desc>
      <desc code="24">OTD Bancaire</desc>
      <desc code="25">OTD Autres tiers</desc>
  </CodeEtape>
     <Civilite>
         <desc code="1">Mademoiselle</desc>
         <desc code="2">Mesdemoiselles</desc>
         <desc code="3">Madame</desc>
         <desc code="4">Mesdames</desc>
         <desc code="5">Monsieur</desc>
         <desc code="6">Messieurs</desc>
         <desc code="7">Monsieur et Madame</desc>
         <desc code="8">Monsieur ou Madame</desc>
         <desc code="9">Madame et Monsieur</desc>
         <desc code="10">Madame ou Monsieur</desc>
         <desc code="56">Collge</desc>
         <desc code="63">Direction</desc>
         <desc code="65">Ecole</desc>
         <desc code="70">Facult</desc>
         <desc code="73">Hopital</desc>
         <desc code="74">Hospice</desc>
         <desc code="79">Lyce</desc>
         <desc code="81">Mairie</desc>
         <desc code="82">Ministre</desc>
         <desc code="88">Prfecture</desc>
         <desc code="96">Sous-prfecture</desc>
         <desc code="98">Syndicat</desc>
         <desc code="99">Universit</desc>
         <desc code="101">Rgion</desc>
         <desc code="102">Dpartement</desc>
     </Civilite>
     <Code>
         <desc code="1">Dlai accord</desc>
         <desc code="2">Rclamation transmise ordo</desc>
         <desc code="3">Suspension demande ordo</desc>
         <desc code="4">Opposition  poursuite</desc>
         <desc code="5">Redressement jud</desc>
         <desc code="6">Liquidation bien</desc>
         <desc code="7">Liquidation judiciaire</desc>
         <desc code="8">Surendettement</desc>
         <desc code="9">NPAI PSA</desc>
         <desc code="10">Annulation attendue</desc>
         <desc code="11">ANV demande</desc>
         <desc code="12">Dbiteur dcd</desc>
         <desc code="13">Autorisation pours non accorde</desc>
         <desc code="14">crance minime</desc>
         <desc code="15">PV carence</desc>
         <desc code="16">Personne disparue</desc>
         <desc code="17">ANV</desc>
         <desc code="18">Plan rglement</desc>
         <desc code="19">Assignation rjlj</desc>
         <desc code="20">Cession fonds</desc>
         <desc code="21">Pourvoi tribx</desc>
         <desc code="22">DR demande</desc>
         <desc code="23">Tiers non rattach</desc>
         <desc code="24">Plan de recouvrement inconnu</desc>
         <desc code="25">Rglement attendu</desc>
         <desc code="26">Poursuite  l'initiative du poste</desc>
         <desc code="27">Rgl par l'aide mdicale</desc>
         <desc code="28">Production notaire</desc>
         <desc code="29">Poursuites sans effet</desc>
         <desc code="30">Certificat d'indigence</desc>
         <desc code="31">Autorisation de poursuivre diffre</desc>
         <desc code="32">Attente rponse huissier ou TI</desc>
         <desc code="33">PV de perquisition</desc>
         <desc code="34">PV de recherche</desc>
         <desc code="35">Vente - Autorisation refuse</desc>
         <desc code="36">Divers</desc>
         <desc code="37">Transfer BC Bnficiaire</desc>
         <desc code="38">Contestation de la crance</desc>
         <desc code="39">Prlvement priodiques</desc>
         <desc code="40">Empchement technique</desc>
         <desc code="41">Paiement hpital public rejet</desc>
         <desc code="42">Paiement hpital public partiel ou nul</desc>
         <desc code="43">Phase Comminatoire (OTD)</desc>
         <desc code="44">OTD (en cours)</desc>
     </Code>
 </xsl:variable>

 <xsl:template match="/*[position()=1]">
  <xsl:choose>
   <xsl:when test="local-name(.) = 'PosteComptable'">
    <n:PosteComptable
     xmlns:n="http://www.minefi.gouv.fr/cp/helios/pes_v2/erar/r0/restit"
     xmlns="http://www.minefi.gouv.fr/cp/helios/pes_v2/erar/r0/restit"
     xmlns:added="http://projets.admisource.gouv.fr/xemelios/namespaces#added"
     xmlns:ano="http://projets.admisource.gouv.fr/xemelios/namespaces#anomally">
        <xsl:attribute name="IdPost"><xsl:value-of select="./@IdPost"/></xsl:attribute>
        <xsl:attribute name="LibellePoste"><xsl:value-of select="./@LibellePoste"/></xsl:attribute>
        <xsl:attribute name="IdColl"><xsl:value-of select="./@IdColl"/></xsl:attribute>
        <xsl:attribute name="FinJur"><xsl:value-of select="./@FinJur"/></xsl:attribute>
        <xsl:attribute name="CodCol"><xsl:value-of select="./@CodCol"/></xsl:attribute>
        <xsl:attribute name="CodBud"><xsl:value-of select="./@CodBud"/></xsl:attribute>
        <xsl:attribute name="LibelleColBud"><xsl:value-of select="./@LibelleColBud"/></xsl:attribute>
     <xsl:for-each select="./*">
      <xsl:call-template name="writeElement">
       <xsl:with-param name="el" select="."/>
      </xsl:call-template>
     </xsl:for-each>
    </n:PosteComptable>
   </xsl:when>
  </xsl:choose>
 </xsl:template>


 <xsl:template name="writeElement">
  <xsl:param name="el"/>
  <xsl:element name="{name($el)}" namespace="http://www.minefi.gouv.fr/cp/helios/pes_v2/erar/r0/restit">
   <xsl:for-each select="$el/@*">
    <xsl:attribute name="{name(.)}">
     <xsl:value-of select="."/>
    </xsl:attribute>
       <xsl:if test="contains('|CatTiers|NatJur|EtatEtape|CodeActu|TypTiers|NatIdTiers|TypeRef|TypAdr|EtatValidation|OrigineEtape|CodeEtape|Code|',concat('|',local-name(.),'|'))">
           <xsl:call-template name="getLibelle">
               <xsl:with-param name="type" select="name(.)"/>
               <xsl:with-param name="code" select="."/>
           </xsl:call-template>
       </xsl:if>
   </xsl:for-each>
   <xsl:choose>
    <xsl:when
     test="contains('|Empechement|Etape|',concat('|',name($el),'|'))">
     <xsl:attribute name="generated-id" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
      <xsl:value-of select="generate-id()"/>
     </xsl:attribute>
    </xsl:when>
   </xsl:choose>
   <xsl:if test="contains('|NPAI|',concat('|',local-name($el),'|'))">
    <xsl:attribute name="NPAI-normalized" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
     <xsl:choose>
      <xsl:when test="$el/@V='true'">1</xsl:when>
      <xsl:when test="$el/@V='yes'">1</xsl:when>
      <xsl:when test="$el/@V='1'">1</xsl:when>
      <xsl:otherwise>0</xsl:otherwise>
     </xsl:choose>
    </xsl:attribute>
   </xsl:if>
      <xsl:if test="contains('|LigneERAR|',concat('|',local-name($el),'|'))">
          <xsl:if test="not(exists(@DatePrescription))">
              <xsl:attribute name="DatePrescription">2299-12-31</xsl:attribute>
          </xsl:if>
          <xsl:if test="not(exists(@DateFinFact)) and exists(@DateDebutFact)">
              <xsl:attribute name="DateFinFact">2299-12-31</xsl:attribute>
          </xsl:if>
          <xsl:attribute name="RarTotal"><xsl:value-of select="@RarPrincipal + @RarFrais"/></xsl:attribute>
      </xsl:if>
      <xsl:choose>
          <xsl:when test="contains('|Empechement|',concat('|',local-name($el),'|'))">
              <xsl:if test="not(exists(@DateDebut))">
                      <xsl:attribute name="DateDebut">1900-01-01</xsl:attribute>
              </xsl:if>
              <xsl:if test="not(exists(@DateFin))">
                  <xsl:attribute name="DateFin">2299-12-31</xsl:attribute>
              </xsl:if>
          </xsl:when>
          <xsl:when test="contains('|Malade|',concat('|',local-name($el),'|'))">
              <xsl:if test="not(exists(@DateSortie)) and exists(@DateEntree)">
                  <xsl:attribute name="DateSortie">2299-12-31</xsl:attribute>
              </xsl:if>
          </xsl:when>
      </xsl:choose>
      
      <xsl:for-each select="$el/*">
    <xsl:call-template name="writeElement">
     <xsl:with-param name="el" select="."/>
    </xsl:call-template>
   </xsl:for-each>
   <xsl:value-of select="$el/text()"/>
  </xsl:element>
 </xsl:template>

 <xsl:template name="getLibelle">
  <xsl:param name="type" as="xs:string"/>
  <xsl:param name="code" as="xs:string"/>
     <xsl:attribute name="{concat($type,'-lib')}" namespace="http://projets.admisource.gouv.fr/xemelios/namespaces#added">
      <xsl:value-of select="$nomenclature/child::node()[local-name()=$type]/desc[@code=$code]/text()"/>
     </xsl:attribute>
 </xsl:template>

</xsl:transform>
