/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fr.gouv.finances.cp.xemelios.erar.plugins;

import fr.gouv.finances.cp.utils.ui.DisplayExceptionDlg;
import fr.gouv.finances.cp.xemelios.common.config.PropertyModel;
import fr.gouv.finances.cp.xemelios.data.DataConfigurationException;
import fr.gouv.finances.cp.xemelios.data.DataLayerManager;
import fr.gouv.finances.cp.xemelios.data.DataResultSet;
import fr.gouv.finances.cp.xemelios.data.impl.MySqlDataLayer;
import fr.gouv.finances.cp.xemelios.data.impl.mysql.MySqlDataResultSetDocGenerator;
import fr.gouv.finances.cp.xemelios.data.impl.sqlconfig.TDocument;
import fr.gouv.finances.cp.xemelios.data.impl.sqlconfig.TEtat;
import fr.gouv.finances.cp.xemelios.plugins.ExportPlugin;
import fr.gouv.finances.cp.xemelios.plugins.SearchPlugin;
import fr.gouv.finances.cp.xemelios.ui.search.ResultDisplayerThread;
import java.io.File;
import java.io.IOException;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import javax.swing.SwingUtilities;
import org.apache.log4j.Logger;

/**
 *
 * @author chm
 */
public class TotalisationDebiteur extends SearchPlugin {
    private static final Logger logger = Logger.getLogger(TotalisationDebiteur.class);
    private TDocument pc = null;
    MySqlDataLayer layer;
    private TEtat ec = null;
    private String CRLF="\n";
    private String request;
    private DecimalFormat df;

    public TotalisationDebiteur() {
        super();
        try {
            layer = (MySqlDataLayer)DataLayerManager.getImplementation();
        } catch(Exception ex) {
            logger.error("<init>",ex);
        }
        
    }
//    @Override
//    public Long doExport() throws Exception {
//        String rq = null;
//        rq = getParameterizedRequest(request);
//        writeHeader();
//        long count = 0L;
//        Connection con = null;
//        try {
//            ResultSet rs = layer.execute(rq);
//            try {
//                con = rs.getStatement().getConnection();
//            } catch(Throwable t) {}
//            while(rs.next()) {
//                writeLine(rs);
//                count++;
//            }
//        } catch(SQLException sqlEx) {
//            logger.error("",sqlEx);
//        } finally {
//            if(con!=null) layer.releaseConnection(con);
//        }
//        writeFooter();
//        return count;
//    }
    
//    protected void writeHeader() throws IOException {
//        getWriter().write(getPluginModel().getEntete().getLibelle()+CRLF);
//    }
//    protected void writeFooter() {
//    }
//    protected void writeLine(ResultSet rs) throws SQLException, IOException {
//        StringBuffer buff = new StringBuffer();
//        int i=1;
//        String idTiers = rs.getString(i++);
//        String nom = rs.getString(i++);
//        String prenom = rs.getString(i++);
//        String adr1 = rs.getString(i++);
//        String adr2 = rs.getString(i++);
//        String adr3 = rs.getString(i++);
//        String cp = rs.getString(i++);
//        String ville = rs.getString(i++);
//        BigDecimal montant = rs.getBigDecimal(i++);
//        buff.append(unnull(idTiers)).append(";").append(unnull(nom)).append(";").append(unnull(prenom)).append(";").append(unnull(adr1)).append(";").append(unnull(adr2)).append(";").append(unnull(adr3)).append(";").append(unnull(cp)).append(";").append(unnull(ville)).append(";");
//        buff.append(df.format(montant));
//        buff.append(CRLF);
//        getWriter().write(buff.toString());
//    }
    protected static String unnull(String  s) { return s!=null?s:""; }
    @Override
    public void computeParameters() throws Exception {
        pc = layer.getPersistenceConfig(getDocumentModel()).getLayer("mysql").getDocument(getDocumentModel().getId());
        ec = pc.getEtat(getEtatModel().getId());
        for(PropertyModel pm:getPluginModel().getProperties()) {
            if("request".equals(pm.getName())) request=pm.getValue();
        }
    }

//    @Override
//    public String getDefaultFileExtension() {
//        return "csv";
//    }
    protected String getParameterizedRequest(final String rq) throws DataConfigurationException {
        String data = rq;
        // first, change table names
        int posParam = data.indexOf("${");
        while(posParam>=0) {
            int posEnd = data.indexOf('}',posParam);
            if(posEnd<0) throw new DataConfigurationException("Invalid request: "+rq);
            String paramName = data.substring(posParam+2,posEnd);
            String paramValue = null;
            if(paramName.startsWith("table-")) {
                String typeTable = paramName.substring(6);
                if(typeTable.startsWith("index-")) {
                    String indexId = typeTable.substring(6);
                    paramValue = ec.getIndexTable(indexId).getBaseName();
                } else {
                    throw new DataConfigurationException("can only deal with index tables: ${"+paramName+"}");
                }
            } else if(paramName.equals("collectivite")) {
                paramValue=getCollectivite().key;
            } else if(paramName.equals("budget")) {
                paramValue = getBudget().key;
            } else {
                throw new DataConfigurationException("can only deal with tables parameters: ${"+paramName+"}");
            }
            if(paramValue==null) throw new DataConfigurationException("no value found for param ${"+paramName+"}");
            data = data.replaceAll("\\$\\{"+paramName+"\\}",paramValue);
            // next round
            posParam = data.indexOf("${");
        }
//        logger.debug(data);
        
        // next, change parameters
        int pos = data.indexOf("##");
        while(pos>=0) {
            int endPos=data.indexOf("##",pos+2);
            if(endPos<0) throw new DataConfigurationException("invalid expression near "+data.substring(pos));
            String pattern=data.substring(pos,endPos+2);
            String paramName = pattern.substring(2,pattern.length()-2);
//            logger.debug("itemName="+itemName);
            String paramValue=getParameters().get(paramName);
            if (paramValue!=null) {
                data = data.replace(pattern,paramValue);
            } else {
                data = data.replace(pattern,"\"\"");
            }
            pos = data.indexOf("##");
        }
        return data;
    }

    @Override
    public DataResultSet doInBackground() throws Exception {
        try {
            String rq = getParameterizedRequest(request);
            String xslFileName = getElementModel().getParent().getParent().getParameters().getParameter("xsl.doc.generator").getValue();
            File xslFile = new File(new File(getElementModel().getParent().getParent().getBaseDirectory()),xslFileName);
            return new MySqlDataResultSetDocGenerator(getElementModel(),getCollectivite(),getBudget(),getElementModel().getPath().getPath(),rq,getListeResultat(),layer,xslFile);
        } catch(Exception ex) {
            logger.error(ex);
        }
        return layer.getEmptyDataResultSet();
    }
    @Override
    public void done() {
        try {
            DataResultSet rs = (DataResultSet)get();
            Runnable code = new ResultDisplayerThread(rs,getListeResultat(),getStart(),getElementModel(),getSearchWindow());
            if(SwingUtilities.isEventDispatchThread()) code.run();
            else try { SwingUtilities.invokeAndWait(code); } catch(Throwable t) {}
            firePropertyChange("COMPLETED",Boolean.FALSE,Boolean.TRUE);
        } catch(Throwable t) {
            DisplayExceptionDlg.displayException(getOwner(),t);
        } finally {
            setProgressVisible(false);
            super.done();
        }
    }

}
