/*
 * Copyright 
 *   2008 axYus - www.axyus.com
 *   2008 jp.tessier - jean-philippe.tessier@axyus.com
 * 
 * This file is part of XEMELIOS.
 * 
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.plugin.generatorEdmn;

import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;

import fr.gouv.finances.cp.utils.ui.InfiniteGlassPane;

/**
 *
 * @author  jp.tessier
 */
public class DlgGenEdmn extends javax.swing.JDialog {
	private static final long serialVersionUID = 3977304325945658517L;
//	private static String PATH_FILE_CHOOSER = "C:/XEMELIOS_FICHIERS/EDMN_2006/1trim";
	String lastDiredtory =""; 
    /** Creates new form DlgGenEdmn */
    public DlgGenEdmn(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        setLocationRelativeTo(getParent());
        InfiniteGlassPane glassPane = new InfiniteGlassPane();
        this.setGlassPane(glassPane);
        if(System.getProperty("xemelios.mysql.config.filename")==null){
        	browse_edmn.setVisible(false);
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        file_edmn = new javax.swing.JTextField();
        browse_edmn = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        file_index = new javax.swing.JTextField();
        browse_index = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        cancel_button = new javax.swing.JButton();
        valid_button = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        file_mysql = new javax.swing.JTextField();
        browse_mysql = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Gnration de flux EDMN");
        
        jLabel1.setText("Fichier EDMN : ");
        

        browse_edmn.setText("Choisir ...");
        browse_edmn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse_edmnActionPerformed(evt);
            }
        });

        jLabel2.setText("Fichier Index :");

        browse_index.setText("Choisir ...");
        browse_index.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse_indexActionPerformed(evt);
            }
        });

        cancel_button.setText("Annuler");
        cancel_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel_buttonActionPerformed(evt);
            }
        });

        valid_button.setText("Valider");
        valid_button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                valid_buttonActionPerformed(evt);
            }
        });

        jLabel3.setText("Fichier MySQL : ");
        jLabel3.setVisible(false);
        
        file_mysql.setVisible(false);

        browse_mysql.setVisible(false);
        browse_mysql.setText("Choisir ...");
        browse_mysql.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browse_mysqlActionPerformed(evt);
            }
        });

        file_mysql.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                fileMysqlCaretUpdate(evt);
            }
        });
        
        file_edmn.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                fileEdmnCaretUpdate(evt);
            }
        });
        
        file_index.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                fileIndexCaretUpdate(evt);
            }
        });
        
        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap(516, Short.MAX_VALUE)
                .add(cancel_button)
                .add(18, 18, 18)
                .add(valid_button)
                .addContainerGap())
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jSeparator1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 678, Short.MAX_VALUE)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel1, 0, 0, Short.MAX_VALUE)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(file_mysql, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 492, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(browse_mysql))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(file_edmn, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 492, Short.MAX_VALUE)
                            .add(file_index, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 492, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(browse_edmn)
                            .add(browse_index))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(browse_mysql)
                    .add(file_mysql, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(browse_edmn)
                    .add(file_edmn, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(browse_index)
                    .add(file_index, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(jSeparator1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 10, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(valid_button)
                    .add(cancel_button))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    
    private void browse_mysqlActionPerformed(java.awt.event.ActionEvent evt) {                                             
    
    }
    
    private void fileMysqlCaretUpdate(javax.swing.event.CaretEvent evt) {                                           
    	if (file_mysql.getText().length() > 0){
    		browse_edmn.setEnabled(true);
    	}else{
    		browse_edmn.setEnabled(false);
    	}
    }
    
    private void fileEdmnCaretUpdate(javax.swing.event.CaretEvent evt) {                                           
    	if (file_edmn.getText().length() > 0){
    		browse_index.setEnabled(true);
    	}else{
    		browse_index.setEnabled(false);
    	}
    }
    
    private void fileIndexCaretUpdate(javax.swing.event.CaretEvent evt) {                                           
    	if (file_edmn.getText().length() > 0 && file_index.getText().length() > 0){
    		valid_button.setEnabled(true);
    	}else{
    		valid_button.setEnabled(false);
    	}
    }
    
    private void browse_edmnActionPerformed(java.awt.event.ActionEvent evt) {                                            
    	JFileChooser fc;
    	if(lastDiredtory.length()>0){
    		fc = new JFileChooser(lastDiredtory);
    	}else if(System.getProperty("xemelios.edmn.directory")!=null){
    		fc = new JFileChooser(System.getProperty("edmn.directory"));
    	}else{    	
    		fc = new JFileChooser();
    	}    	
    	fc.addChoosableFileFilter(new FileFilter() {
            public boolean accept(File f) {
                return f.isDirectory() || f.getName().toUpperCase().endsWith("TXT");
            }
            public String getDescription() {
                return "Fichiers EDMN";
            }
        });
        int reponse = fc.showOpenDialog(this);        
        if(reponse==JFileChooser.APPROVE_OPTION) {
            file_edmn.setText(fc.getSelectedFile().getAbsolutePath());
            lastDiredtory=fc.getSelectedFile().getParent();
        }
    }

    private void browse_indexActionPerformed(java.awt.event.ActionEvent evt) {                                             
    	JFileChooser fc;
    	if(lastDiredtory.length()>0){
    		fc = new JFileChooser(lastDiredtory);
    	}else if(System.getProperty("xemelios.edmn.directory")!=null){
    		fc = new JFileChooser(System.getProperty("edmn.directory"));
    	}else{
    		fc = new JFileChooser();
    	}
    	fc.addChoosableFileFilter(new FileFilter() {
            public boolean accept(File f) {
                return f.isDirectory() || f.getName().toUpperCase().endsWith("TXT");
            }
            public String getDescription() {
                return "Fichiers INDEX";
            }
        });
        int reponse = fc.showOpenDialog(this);        
        if(reponse==JFileChooser.APPROVE_OPTION) {
            file_index.setText(fc.getSelectedFile().getAbsolutePath());
            lastDiredtory=fc.getSelectedFile().getParent();
        }
    }

    private void cancel_buttonActionPerformed(java.awt.event.ActionEvent evt) {                                              
        setVisible(false);
    }

    private void valid_buttonActionPerformed(java.awt.event.ActionEvent evt) {                                             
        EdmnImporter edmni = new EdmnImporter(this);
        try {
        	startVentilateur();
			edmni.importFile(new File(file_edmn.getText()),new File(file_index.getText()));
			stopVentilateur();
		} catch (Exception e) {
			stopVentilateur();
			e.printStackTrace();
		}		
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                DlgGenEdmn dialog = new DlgGenEdmn(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    
    public void stopVentilateur() {
        getGlassPane().setVisible(false);
    }
    
    public void startVentilateur() {
        getGlassPane().setVisible(true);
    }
        
    public void run() {
        setVisible(true);
    }
    
	public void setFile_edmn(String text) {
		this.file_edmn.setText(text);
	}

	public void setFile_index(String text) {
		this.file_index.setText(text);
	}
	
	public void setBrowseIndexEnabled(boolean b){
		browse_index.setEnabled(b);
	}
	
	public void setValidBouttonEnabled(boolean b){
		valid_button.setEnabled(b);
	}
	
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton browse_edmn;
    private javax.swing.JButton browse_index;
    private javax.swing.JButton browse_mysql;
    private javax.swing.JButton cancel_button;
    private javax.swing.JTextField file_edmn;
    private javax.swing.JTextField file_index;
    private javax.swing.JTextField file_mysql;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JButton valid_button;
    // End of variables declaration//GEN-END:variables

    
    
}
