/*
 * Copyright
 *   2008 axYus - www.axyus.com
 *   2008 L.Meckert - laurent.meckert.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fr.gouv.finances.cp.xemelios.plugin.signerfichier;
import java.io.File;
import java.util.Enumeration;
import javax.xml.namespace.NamespaceContext;
/**
 *
 * @author laurent.meckert
 */
public interface IFileSigner {

   public void setNsCtx(NamespaceContext ctx);



 /**
   * 
   * @return
   */
  public File getInputFile() ;

  /**
   * 
   * @param inf 
   */
  public void setInputFile(File inf) ;
  
  /**
   * 
   * @return
   */
  public File getOutputFile() ;

  /**
   * 
   * @param outf 
   */
  public void setOutputFile(File outf) ;
   /**
   * 
   * @return
   */
  public File getKeystoreFile() ;

  /**
   * 
   * @param kf 
   */
  public void setKeystoreFile(File kf) ;
  
  /**
   * 
   * @return
   */
  public String getKeystoreType();
  

  /**
   * 
   * @param password
   *
   */
  public void setKeystorePassword(String password);
  


 public String getKeystorePassword();

  /**
   * 
   */
  public void loadKeystore()  throws Exception;
  
  /**
   * 
   */
  public void loadInputFile()  throws Exception;
  
  /**
   * 
   * @return
   */
  public Enumeration getAliases()  throws Exception;
  
  
  /**
   * 
   * @param alias
   */
  public void setAlias(String alias) ;
  

 /**
   * 
   * 
   */
  public String getAlias() ;


  /**
   * 
   * @param alias
   * @param password
   */
  public void setAliasPassword( String password);
  


  /**
   * 
   * @param xpath
   */
  public void addSubtractFilter(String xpath);
  /**
   * 
   * @param xpath
   */
  public void addIntersectFilter(String xpath);
  
  public void loadAlias();
  
  /**
   * 
   * @throws Exception 
   */
  public void sign()  throws Exception;
  
  /**
   * 
   * @return
   */
  public String getStatusAsString();

  /**
   * 
   * @return
   */
  public int getStatusAsSeverity();




  /**
   *
   * @return true si le fichier XML a ete correctement pars
   */
   public boolean parseOK();

  /**
   *
   * @return true si le keystore est bien charge
   */
   public boolean loadKsOK();
 /**
   *
   * @return true si la cle privee est bien charge
   */
   public boolean loadPkOK() ;
 /**
   *
   * @return true si l'algorithme de signature est supporte
   */
  public boolean algoIdOK();

  /**
   *
   * @return true si signature ok
   */
   public boolean signOK();

  /**
   *
   * @return true si fichier de sortie nbien ecrit
   */
   public boolean writeOK();

  /**
   * 
   * @nettoyage
   */
   public void dispose() ;


}
