/*
 * Copyright
 *   2008 axYus - www.axyus.com
 *   2008 L.Meckert - laurent.meckert.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.gouv.finances.cp.xemelios.plugin.signerfichier;

/*
 * DlgSignerfichier.java
 *
 * Created on 23 septembre 2008, 09:16
 */
import javax.swing.JFrame;
import java.io.File;

import java.util.Enumeration;

/**
 *
 * @author  laurent.meckert
 */
public class DlgSignerfichier extends AbstractDlgSignerfichier {

 

  void showSelectedInputFile(File f) {
    textFieldInputFile.setText(f.getAbsolutePath());
  }

  void showSelectedCertFile(File f) {
    textFieldCertFile.setText(f.getAbsolutePath());
  }

  /** Creates new form DlgSignerfichier
   * @param parent
   * @param modal 
   */
  public DlgSignerfichier(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();

    dialog.setLocationRelativeTo(parent);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  private void initComponents() {

    jButtonInputFile = new javax.swing.JButton();
    textFieldInputFile = new java.awt.TextField();
    label1 = new java.awt.Label();
    jLabel2 = new javax.swing.JLabel();
    textFieldCertFile = new java.awt.TextField();
    jButtonCertFile = new javax.swing.JButton();
    label2 = new java.awt.Label();
    jButtonOK = new javax.swing.JButton();
    jComboBoxAliases = new javax.swing.JComboBox();
    jButtonAnnuler = new javax.swing.JButton();
    label4 = new java.awt.Label();
    label3 = new java.awt.Label();

    dialog.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

    jButtonInputFile.setText("...");
    jButtonInputFile.setName("jButtonInputFile"); // NOI18N
    jButtonInputFile.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButtonInputFileActionPerformed(evt);
      }
    });

    textFieldInputFile.setEnabled(false);
    textFieldInputFile.setName("textFieldInputFile"); // NOI18N

    label1.setText("1) Chosir le fichier  signer");

    jLabel2.setFont(new java.awt.Font("Tahoma", 1, 13));
    jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    jLabel2.setText("SIGNER UN FICHIER PES");

    textFieldCertFile.setEnabled(false);
    textFieldCertFile.setName("textFieldInputFile"); // NOI18N

    jButtonCertFile.setText("...");
    jButtonCertFile.setName("jButtonCerttFile"); // NOI18N
    jButtonCertFile.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButtonCertFileActionPerformed(evt);
      }
    });

    label2.setText("2) Choisir  un fichier de type \"magasin de cls\"");

    jButtonOK.setText("OK");
    jButtonOK.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButtonOKActionPerformed(evt);
      }
    });

    jComboBoxAliases.setModel(new javax.swing.DefaultComboBoxModel(new String[]{"Item 1", "Item 2", "Item 3", "Item 4"}));

    jButtonAnnuler.setText("Annuler");
    jButtonAnnuler.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(java.awt.event.ActionEvent evt) {
        jButtonAnnulerActionPerformed(evt);
      }
    });

    label4.setText("3) Choisir votre cl prive");

    label3.setText("3) Lancer la signature");

    org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(dialog.getContentPane());
    dialog.getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(layout.createSequentialGroup().add(27, 27, 27).add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).add(layout.createSequentialGroup().add(jButtonOK).addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 277, Short.MAX_VALUE).add(jButtonAnnuler)).add(layout.createSequentialGroup().add(22, 22, 22).add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 381, Short.MAX_VALUE)).add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).add(label4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).add(layout.createSequentialGroup().add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(textFieldInputFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 303, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 315, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).add(textFieldCertFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 303, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)).add(43, 43, 43).add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING).add(jButtonInputFile).add(jButtonCertFile))).add(jComboBoxAliases, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 325, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)).addContainerGap(23, Short.MAX_VALUE)));
    layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(layout.createSequentialGroup().addContainerGap().add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 16, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).add(21, 21, 21).add(label1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED).add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(textFieldInputFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).add(jButtonInputFile)).add(17, 17, 17).add(label2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED).add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING).add(layout.createSequentialGroup().add(jButtonCertFile).add(14, 14, 14).add(label4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)).add(textFieldCertFile, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)).add(1, 1, 1).add(jComboBoxAliases, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 33, Short.MAX_VALUE).add(label3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 32, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE).add(2, 2, 2).add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE).add(jButtonOK).add(jButtonAnnuler)).add(20, 20, 20)));

    label1.getAccessibleContext().setAccessibleName("1) Choisir le fichier  signer");
    label3.getAccessibleContext().setAccessibleName("4) Lancer la signature");

    dialog.pack();
  }

  private void jButtonInputFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonInputFileActionPerformed

    jButtonCertFile.setEnabled(false);
    try {
      Actions.getInstance().chooseInputFile();
    } catch (Exception e) {
      e.printStackTrace();
    }
    if (Actions.getInstance().getFileToSign() != null) {
      showSelectedInputFile(Actions.getInstance().getFileToSign());

      jButtonCertFile.setEnabled(true);
    }

  }//GEN-LAST:event_jButtonInputFileActionPerformed

  private void jButtonCertFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCertFileActionPerformed
    // TODO add your handling code here:
    try {
      Actions.getInstance().chooseCertFile();
    } catch (Exception e) {
      e.printStackTrace();
    }
    if (Actions.getInstance().getCertFile() != null) {
      showSelectedCertFile(Actions.getInstance().getCertFile());
    }
    jComboBoxAliases.removeAllItems();

    try {
      for (Enumeration e = Actions.getInstance().getAliases(); e.hasMoreElements();) {
        //System.out.println(e.nextElement());
        jComboBoxAliases.addItem(e.nextElement());
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
    jButtonOK.setEnabled(true);

  }//GEN-LAST:event_jButtonCertFileActionPerformed

  private void jButtonAnnulerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonAnnulerActionPerformed
    // TODO add your handling code here:
    close();
  }//GEN-LAST:event_jButtonAnnulerActionPerformed

  private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
    // TODO add your handling code here:
    boolean ret = Actions.getInstance().loadAlias(jComboBoxAliases.getSelectedItem());
    if (ret) {
      try {
        Actions.getInstance().chooseOutputFile();
      } catch (Exception e) {
        e.printStackTrace();
      }
      if (Actions.getInstance().getFileToGenerate() != null) {
        setBusy(true);
        try {
          Actions.getInstance().doSign();
        } catch (Exception e) {
          e.printStackTrace();
          }

        setBusy(false);
        Actions.getInstance().showStatus();



        close();
      } else {
        Actions.getInstance().showStatus();
        return;
      }

    }

  }//GEN-LAST:event_jButtonOKActionPerformed

  public void initOthers() {
    jButtonCertFile.setEnabled(false);
    jButtonOK.setEnabled(false);
    jComboBoxAliases.removeAllItems();
    dialog.setSize(465, 470);
  }

  public void close() {
    System.out.println("closing dialog (DlgSignerFichier)");
    
    super.close();
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    Runnable mainTask = new Runnable() {

      public void run() {
        JFrame frame = new JFrame("test");
        DlgSignerfichier dialog = new DlgSignerfichier(frame, true);
        dialog.dialog.addWindowListener(new java.awt.event.WindowAdapter() {

          @Override
          public void windowClosing(java.awt.event.WindowEvent e) {
            System.exit(0);
          }
        });

        dialog.run();
      }
    };

    Thread t = new Thread(mainTask);
    t.setPriority(Thread.NORM_PRIORITY);

    java.awt.EventQueue.invokeLater(t);

  }
// Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton jButtonAnnuler;
  private javax.swing.JButton jButtonInputFile;
  private javax.swing.JButton jButtonCertFile;
  private javax.swing.JButton jButtonOK;
  private javax.swing.JComboBox jComboBoxAliases;
  private javax.swing.JLabel jLabel2;
  private java.awt.Label label1;
  private java.awt.Label label2;
  private java.awt.Label label3;
  private java.awt.Label label4;
  private java.awt.TextField textFieldCertFile;
  private java.awt.TextField textFieldInputFile;// End of variables declaration//GEN-END:variables
}
