/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.gouv.finances.cp.xemelios.plugin.signerfichier;

import org.netbeans.api.wizard.WizardDisplayer;
import org.netbeans.spi.wizard.*;
import java.util.Map;
import java.io.File;

/**
 *
 * @author laurent.meckert
 */
public class WizardSignerFichier extends AbstractDlgSignerfichier {

  private Wizard wizard = null;

  /**
   * 
   * @param parent
   * @param modal
   */
  public WizardSignerFichier(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
   
  }

  @Override
  void initOthers() {
//    throw new UnsupportedOperationException("Not supported yet.");
  }

  @Override
  public void run() {
    final Class[] pages = new Class[]{
      InputFilePanel.class,
      CertFilePanel.class,
      CertChoicePanel.class,
      OutputFilePanel.class
    };
    //initGlassPane();
    initSigner();
    initOthers();
    MyProducer mp = new MyProducer();
    wizard = WizardPage.createWizard("Signature d'un fichier PES", pages, mp);
    System.out.println("Result = " +
            WizardDisplayer.showWizard(wizard));
    Actions.getInstance().dispose();

  }

  @Override
  void showSelectedInputFile( File f) {//    throw new UnsupportedOperationException("Not supported yet.");
  }
}

class MyProducer implements WizardPage.WizardResultProducer {

  public Object finish(Map wizardData) throws WizardException {
    System.out.println("finish called");
    System.out.println(wizardData);

    String[] items = new String[4];
    items[0] = "Fichier a signer: " + wizardData.get("TextFieldInputFile");
    items[1] = "Magasin de cles: " + wizardData.get("TextFieldCertFile");
    items[2] = "Certificat utilis: " + wizardData.get("jComboBoxAliases");
    items[3] = "Fichier sign: " + wizardData.get("TextFieldOutputFile");


    //  return Summary.create(items, null);
    return new MyDeferredWizardResult();
  }

  public boolean cancel(Map settings) {
    System.out.println("cancel called");
    System.out.println(settings);

    return true; // Allow the user to cancel the wizard.
  }

  class MyDeferredWizardResult extends DeferredWizardResult {

    public MyDeferredWizardResult() {
      super(true, true);
    }

    public void start(java.util.Map settings,
            ResultProgressHandle progress) {
      try {
        Actions.getInstance().doSign();
        String[] items = new String[5];
        items[0] = "Fichier a signer: " + Actions.getInstance().getFileToSign().getAbsolutePath();
        items[1] = "Magasin de cles: " + Actions.getInstance().getCertFile().getAbsolutePath();
        items[2] = "Certificat utilis: " + Actions.getInstance().getAliasName();
        items[3] = "Fichier sign: " + Actions.getInstance().getFileToGenerate().getAbsolutePath();
        items[4] = "Rsultat: " + Actions.getInstance().getSignStatusString();


        //  return Summary.create(items, null);
        Actions.getInstance().showStatus();
        progress.finished(Summary.create(items, null));//Actions.getInstance());
      } catch (Exception e) {
        Actions.getInstance().showStatus();
        progress.failed("Echec de la signature", true);
      }
    }
  }
}
