/*
 * Copyright 
 *   2006 chru-strasbourg - www.chru-strasbourg.fr
 *   2006 V.Fiack - vincent.fiack@chru-strasbourg.fr
 *   20006 C.Marchand - christophe.marchand@axyus.com
 * 
 * This file is part of XEMELIOS.
 * 
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.auth;

import fr.gouv.finances.cp.xemelios.data.DataAccessException;

/**
 * Authenticates user
 */
public interface AuthChecker {
	/**
	 * Authenticates user in underlying authentication system.
	 * This methods sets user roles and returns if user can connect
	 * (i.e. user.isAllowedTo(null,XemeliosUser.ROLE_CONNECT) )
	 * @param user
	 * @return <tt>true</tt> if user can connect
	 */
	public boolean authenticate(XemeliosUser user) throws DataAccessException, AuthenticationConfigurationException;
}