package fr.gouv.finances.dgfip.xemelios.web.connexion;

import fr.gouv.finances.dgfip.xemelios.web.Application;
import fr.gouv.finances.dgfip.xemelios.web.AttributeHelper;
import fr.gouv.finances.dgfip.xemelios.web.Principal;
import fr.gouv.finances.dgfip.xemelios.web.utils.StdDispatchAction;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessages;

/**
 * @author CBO
 * Cette action permet la connexion via le Web SSO LemonLDAP
 */
public class ConnexionAction extends StdDispatchAction {

    @Override
    public ActionForward unspecified(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
        return process(mapping, form, request, response);
    }

    public ActionForward process(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
        // On nettoie la session tout en conservant l'ventuel message d'erreur :
        ActionMessages actionMessages = (ActionMessages) request.getSession().getAttribute(Globals.ERROR_KEY);
        request.getSession().invalidate();
        if (actionMessages != null) {
            request.getSession().setAttribute(Globals.ERROR_KEY, actionMessages);
        }
        Authenticator authenticator = (Authenticator) Class.forName(getServlet().getServletContext().getInitParameter("authenticatorImpl")).newInstance();
        //Authenticator authenticator = new LDAPAuthenticatorImpl();
        Principal principal = authenticator.authenticate(request);
        if (principal != null) {
            AttributeHelper.setPrincipal(request.getSession(), principal);
            AttributeHelper.setMenu(request.getSession(), Application.getMenu());
            return mapping.getInputForward();
        } else {
            response.sendError(HttpServletResponse.SC_FORBIDDEN);
            return null;
        }
    }
}
