package fr.gouv.finances.dgfip.xemelios.web.connexion;

import fr.gouv.finances.dgfip.xemelios.web.Principal;
import fr.gouv.finances.dgfip.xemelios.web.Principal.CodicCodeCol;
import java.sql.SQLException;
import java.util.Arrays;
import java.util.Collection;
import javax.servlet.http.HttpServletRequest;

/**
 * @author CBO
 * Permet dans l'environnement de dev de s'authentifier en admin ou en tant que comptable.
 * Pour le cas admin il n'y a rien de particulier  faire.
 * Pour le cas des comptable il faut passer dans l'url le paramtre codiqueCodeColCodes contenant un ou plusieurs codiqueCodeCol
 */
public class FakeAuthenticatorImpl implements Authenticator {

  public Principal authenticate(HttpServletRequest request) throws AuthenticatorException, SQLException {
    boolean isAdmin = request.getParameterValues("codiqueCodeColCodes") == null;
    String[] codiqueCodeColCodes = request.getParameterValues("codiqueCodeColCodes") != null ? request.getParameterValues("codiqueCodeColCodes") : new String[0];
    return new PrincipalImpl(isAdmin, isAdmin ? "Utilisateur admin" : "Utilisateur standard",
            isAdmin ? getCodeFonctionnalitesUtilisateurAdmin() : getCodeFonctionnalitesUtilisateurStandard(),
            CodicCodeCol.fromCodes(codiqueCodeColCodes));
  }

  private Collection<String> getCodeFonctionnalitesUtilisateurAdmin() {
    return Arrays.asList("AUTHENTIFIE", "ACCUEIL", "RECHERCHE");
  }

  private Collection<String> getCodeFonctionnalitesUtilisateurStandard() {
    return Arrays.asList("AUTHENTIFIE", "ACCUEIL", "RECHERCHE");
  }

}
