package fr.gouv.finances.dgfip.xemelios.web.connexion;

import fr.gouv.finances.dgfip.xemelios.web.Principal;
import fr.gouv.finances.dgfip.xemelios.web.Principal.CodicCodeCol;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class PrincipalImpl implements Principal {

  private boolean admin;
  private String displayName;
  private Collection<String> codeFonctionnalites;
  private List<CodicCodeCol> codiqueCodeCols;

  public PrincipalImpl(boolean admin, String displayName, Collection<String> codeFonctionnalites, List<CodicCodeCol> codiqueCodeCols) {
    this.admin = admin;
    this.displayName = displayName;
    this.codeFonctionnalites = codeFonctionnalites;
    this.codiqueCodeCols = codiqueCodeCols;
  }

  public String getDisplayName() {
    return null;
  }

  public Collection<String> getCodesFonctionnalites() {
    return this.codeFonctionnalites;
  }

  public boolean isAdmin() {
    return admin;
  }

  public List<CodicCodeCol> getCodiqueCodeCols() {
    return this.codiqueCodeCols;
  }

  public List<String> getCodiqueCodeColCodes() {
    List<String> toReturn = new ArrayList<String>(getCodiqueCodeCols().size());
    for (CodicCodeCol codiqueCodeCol : getCodiqueCodeCols()) {
      toReturn.add(codiqueCodeCol.getCode());
    }
    return toReturn;
  }
}
