package fr.gouv.finances.dgfip.xemelios.web.gwt.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.RootPanel;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.utils.DoneListener;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search.SearchWidget;

/** 
 * @author CBO
 */
public class CriteriaBuilderEntryPoint implements EntryPoint {

    static private SearchWidget searchWidget;
    private String documentId;
    private String etatId;
    private String elementId;

    public void onModuleLoad() {
        GWT.setUncaughtExceptionHandler(new GWT.UncaughtExceptionHandler() {

            public void onUncaughtException(Throwable throwable) {
                String text = "Une erreur est survenue: ";
                while (throwable != null) {
                    StackTraceElement[] stackTraceElements = throwable.getStackTrace();
                    text += new String(throwable.toString() + "\n");
                    for (int i = 0; i < stackTraceElements.length; i++) {
                        text += "    at " + stackTraceElements[i] + "\n";
                    }
                    throwable = throwable.getCause();
                    if (throwable != null) {
                        text += "Caused by: ";
                    }
                }
                Window.alert(text);
            }
        });
        this.documentId = RootPanel.get("criteriaContainer").getElement().getAttribute("documentId");
        this.etatId = RootPanel.get("criteriaContainer").getElement().getAttribute("etatId");
        this.elementId = RootPanel.get("criteriaContainer").getElement().getAttribute("elementId");
        CriteriaBuilderEntryPoint.searchWidget = new SearchWidget(documentId, etatId, elementId);
        searchWidget.init(new DoneListener<Object>() {

            public void done(Object nullObject) {
                RootPanel.get("criteriaContainer").add(searchWidget);
            }
        });
    }
}
