package fr.gouv.finances.dgfip.xemelios.web.gwt.client.service;

import com.google.gwt.user.client.rpc.RemoteService;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.InitParametersDTO;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.CritereItemDTO;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.LabelValueDTO;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.SearchParameterDTO;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.SearchResultDTO;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.SelectOneCritereItemDTO;
import java.util.List;
import java.util.Map;

/**
 * @author CBO
 */
public interface XemeliosService extends RemoteService {

    public InitParametersDTO getCWInitParameters(String documentId, String etatId, String elementId);

    public List<LabelValueDTO> getBudgets(String documentId, String collectiviteId);

    public List<CritereItemDTO> getCritereItems(String collectiviteId, String budgetId, String documentId, String etatId, String elementId, String criteriaId);
    
    public SelectOneCritereItemDTO getUpdatedSelectOneCritereItemDTO(String collectiviteId, String budgetId, String documentId, String etatId, String elementId, String critereId, String selectId, Map<String, String>inputValuesById);

    public SearchResultDTO search(String collectiviteId, String budgetId, String documentId, String etatId, String elementId, List<SearchParameterDTO> searchParams);
}
