package fr.gouv.finances.dgfip.xemelios.web.gwt.client.utils;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.StatusCodeException;
import com.google.gwt.user.client.ui.Widget;

/**
 * @author CBO
 */
public class GWTUtils {

    static public final int REMOTE_ERROR_FOR_REDIRECTION_CODE = 1000;

    public static void handleRPCError(Throwable pThrowable) {
        try {
            throw pThrowable;
        } catch(StatusCodeException sce) {
            if (sce.getStatusCode() == GWTUtils.REMOTE_ERROR_FOR_REDIRECTION_CODE) {
                GWTUtils.setURL(sce.getMessage());
            } else {
                handleUnExpectedRPCError(pThrowable);
            }
        } catch(Throwable t) {
            handleUnExpectedRPCError(pThrowable);
        }
    }

    public static native void setURL(String url) /*-{
      $wnd.top.location.href = url;
    }-*/;

    private static void handleUnExpectedRPCError(Throwable throwable) {
        Window.alert("Erreur innatendue" + (throwable != null ? " : " + throwable.toString() : ""));
    }

    static public void hide(Widget widget) {
        DOM.setStyleAttribute(widget.getElement(), "visibility", "hidden");
    }

    static public String getContextPath() {
        return GWT.getModuleBaseURL().replace(GWT.getModuleName() + "/", "");
    }
}
