package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget;

import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.FocusPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.MouseListenerAdapter;
import com.google.gwt.user.client.ui.Widget;

/**
 * @author CBO
 */
public class ImageButton extends Composite {

    private FocusPanel focusPanel;
    private Image image;
    private boolean enabled;

    public ImageButton(String image, String toolTip) {
        this.enabled = true;
        this.focusPanel = new FocusPanel();
        this.image = new Image(image);
        this.focusPanel.add(this.image);
        this.focusPanel.addMouseListener(new MouseListenerAdapter() {

            @Override
            public void onMouseEnter(Widget sender) {
                mouseEnter();
            }

            @Override
            public void onMouseLeave(Widget sender) {
                mouseLeave();
            }
        });
        this.focusPanel.setTitle(toolTip);
        initWidget(this.focusPanel);
        setStyleName("imageButton");
        mouseLeave();
    }

    public void setEnable(boolean enabled) {
        // TODO : modifier l'apparence et le curseur des boutons disabled
        this.enabled = enabled;
    }

    public boolean isEnabled() {
        return enabled;
    }

    private void mouseEnter() {
        DOM.setStyleAttribute(getElement(), "borderStyle", "outset");
        DOM.setStyleAttribute(getElement(), "borderWidth", "1px");
        DOM.setStyleAttribute(getElement(), "margin", "0px");
    }

    private void mouseLeave() {
        DOM.setStyleAttribute(getElement(), "margin", "1px");
        DOM.setStyleAttribute(getElement(), "borderWidth", "0px");
        DOM.setStyleAttribute(getElement(), "cursor", "hand");
    }

    public void addClickListener(final ClickListener cl) {
        focusPanel.addClickListener(new ClickListener() {

            public void onClick(Widget arg0) {
                if (ImageButton.this.enabled) {
                    cl.onClick(ImageButton.this);
                }
            }
        });
    }
}
