package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget;

import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.utils.GWTUtils;

/**
 * @author CBO
 */
public class PaginationWidget extends Composite {

    private HorizontalPanel horizontalPanel;
    private Page page;
    private ImageButton firstButton;
    private ImageButton previousButton;
    private ImageButton nextButton;
    private ImageButton lastButton;

    public PaginationWidget() {
        this.page = Page.emptyPage;
        this.horizontalPanel = new HorizontalPanel();
        this.firstButton = new ImageButton(GWTUtils.getContextPath() + "/img/pagination/first.gif", new HTML("Premi&egrave;re page").getHTML());
        this.previousButton = new ImageButton(GWTUtils.getContextPath() + "/img/pagination/previous.gif", new HTML("Page pr&eacute;c&eacute;dente").getHTML());
        this.nextButton = new ImageButton(GWTUtils.getContextPath() + "/img/pagination/next.gif", new HTML("Page suivante").getHTML());
        this.lastButton = new ImageButton(GWTUtils.getContextPath() + "/img/pagination/last.gif", new HTML("Derni&egrave;re page").getHTML());
        update();
        initWidget(this.horizontalPanel);
    }

    public void setPage(Page page) {
        this.page = page;
        update();
    }

    private void update() {
        this.firstButton.setEnable(hasPrevious());
        this.previousButton.setEnable(hasPrevious());
        this.nextButton.setEnable(hasNext());
    }

    private boolean hasNext() {
        return this.page.getCurrentPageNumber() < this.page.getPageCount();
    }

    private boolean hasPrevious() {
        return this.page.getCurrentPageNumber() > 1;
    }

    static public interface Page {

        static public Page emptyPage = new Page() {

            public int getPageCount() {
                return 0;
            }

            public int getCurrentPageNumber() {
                return -1;
            }
            
        };
        
        int getPageCount();

        int getCurrentPageNumber();
        
        
    }
}
