package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search;

import com.google.gwt.user.client.ui.ChangeListener;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.ListBox;
import com.google.gwt.user.client.ui.Widget;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.CritereTypeDTO;
import java.util.List;

/**
 * @author CBO
 */
public class SelectCritereWidget extends Composite {

    private List<CritereTypeDTO> criteres;
    private ListBox critereListBox;

    public SelectCritereWidget(List<CritereTypeDTO> criteres) {
        this.criteres = criteres;
        this.critereListBox = new ListBox();
        initWidget(this.critereListBox);
        for (CritereTypeDTO critere : criteres) {
            this.critereListBox.addItem(critere.getLibelle(), critere.getId());
        }
    }

    public void addChangeListener(final ChangeListener changeListener) {
        this.critereListBox.addChangeListener(new ChangeListener() {

            public void onChange(Widget widget) {
                changeListener.onChange(SelectCritereWidget.this);
            }
        });
    }

    public CritereTypeDTO getSelectedCritere() {
        if (this.critereListBox.getSelectedIndex() >= 0) {
            return this.criteres.get(this.critereListBox.getSelectedIndex());
        } else {
            return null;
        }
    }
}
