package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search.criteria;

import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Widget;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search.CriteriaTable;
import java.util.ArrayList;
import java.util.List;

/**
 * @author CBO
 */
public class CritereLineContainer extends Composite {

    private CriteriaTable criteriaTable;
    private String critereId;
    private HorizontalPanel horizontalPanel;

    public CritereLineContainer(CriteriaTable criteriaTable, String critereId) {
        this.criteriaTable = criteriaTable;
        this.critereId = critereId;
        this.horizontalPanel = new HorizontalPanel();
        initWidget(this.horizontalPanel);
    }

    public CriteriaTable getCriteriaTable() {
        return criteriaTable;
    }

    public String getCritereId() {
        return critereId;
    }

    public void add(CritereWidget critereWidget) {
        horizontalPanel.add(critereWidget);
    }

    public List<InputCritereWidget> getInputCriteriaWidgets() {
        List<InputCritereWidget> toReturn = new ArrayList<InputCritereWidget>();
        for (int i = 0; i < horizontalPanel.getWidgetCount(); i++) {
            Widget widget = horizontalPanel.getWidget(i);
            if (widget instanceof InputCritereWidget) {
                toReturn.add((InputCritereWidget) widget);
            }
        }
        return toReturn;
    }

    InputCritereWidget getInputCritereWidget(String inputId) {
        for (InputCritereWidget inputCritereWidget : getInputCriteriaWidgets()) {
            if (inputCritereWidget.getInputId().equals(inputId)) {
                return inputCritereWidget;
            }
        }
        return null;
    }
}
