package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search.criteria;

import com.google.gwt.i18n.client.DateTimeFormat;
import com.google.gwt.user.client.ui.TextBox;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.DateCritereItemDTO;

public class DateCritereWidget extends InputCritereWidget {

    private DateCritereItemDTO dateCritereItem;
    private DateTimeFormat dateFormat;
    private TextBox textBox;

    public DateCritereWidget(CritereLineContainer critereLineContainer, DateCritereItemDTO critereItem) {
        super(critereLineContainer, critereItem);
        this.dateCritereItem = critereItem;
        this.dateFormat = DateTimeFormat.getFormat(critereItem.getFormat());
        this.textBox = new TextBox();
        initWidget(textBox);
    }

    @Override
    public void setFocus() {
        this.textBox.setFocus(true);
    }

    @Override
    public String getInputValue() {
        return textBox.getText();
    }

    @Override
    public void refresh() {
        throw new UnsupportedOperationException();
    }

    @Override
    public void checkValidity() throws ValidityException {
        if (isFilled()) {
            try {
                this.dateFormat.parse(getInputValue());
            } catch(IllegalArgumentException pe) {
                throw new ValidityException("La valeur \"" + getInputValue() + "\" n'est pas une date valide, le format attendu est " + dateCritereItem.getFormat());
            }
        }
    }
}
