package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search.criteria;

import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.InputCritereItemDTO;

/**
 * @author CBO
 * Classe de base de tous les composants affichs dans une ligne de critre qui ont une valeur
 */
abstract public class InputCritereWidget extends CritereWidget {

    private InputCritereItemDTO inputCritereItem;

    public String getInputId() {
        return inputCritereItem.getInputId();
    }

    public InputCritereWidget(CritereLineContainer critereLineContainer, InputCritereItemDTO inputCritereItem) {
        super(critereLineContainer);
        this.inputCritereItem = inputCritereItem;
    }

    public boolean isFilled() {
        return getInputValue() != null && !getInputValue().trim().equals("");
    }

    abstract public void setFocus();

    abstract public void refresh();

    abstract public void checkValidity() throws ValidityException;

    abstract public String getInputValue();

    static public class ValidityException extends Exception {
        
        private String messageToDisplay;
        
        public ValidityException(String messageToDisplay) {
            this.messageToDisplay = messageToDisplay;
        }
        
        public String getMessageToDisplay() {
            return this.messageToDisplay;
        }
        
    }
    
}
