package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search.criteria;

import com.google.gwt.i18n.client.NumberFormat;
import com.google.gwt.user.client.ui.KeyboardListenerAdapter;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.NumericCritereItemDTO;

/**
 * @author CBO
 */
public class NumericCritereWidget extends InputCritereWidget {

    private TextBox textBox;

    public NumericCritereWidget(CritereLineContainer critereLineContainer, NumericCritereItemDTO critereItem) {
        super(critereLineContainer, critereItem);
        this.textBox = new TextBox();
        this.textBox.setTextAlignment(TextBox.ALIGN_RIGHT);
        this.textBox.addKeyboardListener(new KeyboardListenerAdapter() {

            @Override
            public void onKeyPress(Widget sender, char keyCode, int modifiers) {
                if ((!Character.isDigit(keyCode)) && (keyCode != (char) KeyboardListenerAdapter.KEY_TAB) && (keyCode != 44) && (keyCode != 45) && (keyCode != (char) KeyboardListenerAdapter.KEY_BACKSPACE) && (keyCode != (char) KeyboardListenerAdapter.KEY_DELETE) && (keyCode != (char) KeyboardListenerAdapter.KEY_ENTER) && (keyCode != (char) KeyboardListenerAdapter.KEY_HOME) && (keyCode != (char) KeyboardListenerAdapter.KEY_END) && (keyCode != (char) KeyboardListenerAdapter.KEY_LEFT) && (keyCode != (char) KeyboardListenerAdapter.KEY_UP) && (keyCode != (char) KeyboardListenerAdapter.KEY_RIGHT) && (keyCode != (char) KeyboardListenerAdapter.KEY_DOWN)) {
                    ((TextBox) sender).cancelKey();
                }
            }
        });
        initWidget(textBox);
    }

    @Override
    public void setFocus() {
        this.textBox.setFocus(true);
    }

    @Override
    public String getInputValue() {
        return textBox.getText();
    }

    @Override
    public void refresh() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void checkValidity() throws ValidityException {
        if (isFilled()) {
            try {
                NumberFormat.getDecimalFormat().parse(getInputValue());
            } catch (NumberFormatException nfe) {
                throw new ValidityException("La valeur \"" + getInputValue() + "\" n'est pas une valeur num&eacute;rique valide");
            }
        }
    }
}
