package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search.criteria;

import com.google.gwt.user.client.ui.KeyboardListenerAdapter;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;
import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.TextCritereItemDTO;

public class TextCritereWidget extends InputCritereWidget {

    private TextBox textBox;

    public TextCritereWidget(CritereLineContainer critereLineContainer, TextCritereItemDTO critereItem) {
        super(critereLineContainer, critereItem);
        this.textBox = new TextBox();
        if (critereItem.isUppercase()) {
            textBox.addKeyboardListener(new KeyboardListenerAdapter() {

                @Override
                public void onKeyPress(Widget sender, char keyCode, int modifiers) {
                    if (Character.isLowerCase(keyCode)) {
                        ((TextBox) sender).setKey(Character.toUpperCase(keyCode));
                    }
                }
            });
        }
        initWidget(textBox);
    }

    @Override
    public void checkValidity() throws ValidityException {
        if (getInputValue() != null && getInputValue().contains("\"")) {
            throw new ValidityException("Les guillemets ne sont pas autoriss");
        }
    }

    @Override
    public void setFocus() {
        this.textBox.setFocus(true);
    }

    @Override
    public void refresh() {
        throw new UnsupportedOperationException("Not supported yet.");
    }
    
    @Override
    public String getInputValue() {
        return textBox.getText();
    }
}
