package fr.gouv.finances.dgfip.xemelios.web.utils;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;

/**
 * @author CBO
 */
public class ByteArrayResponseWrapper extends HttpServletResponseWrapper {

  private ByteArrayServletOuputStream byteArrayServletOuputStream;
  private PrintWriter printWriter;

  public ByteArrayResponseWrapper(HttpServletResponse response) {
    super(response);
    this.byteArrayServletOuputStream = new ByteArrayServletOuputStream();
    this.printWriter = new PrintWriter(this.byteArrayServletOuputStream);
  }

  @Override
  public HttpServletResponse getResponse() {
    return (HttpServletResponse)super.getResponse();
  }

  @Override
  public ServletOutputStream getOutputStream() throws IOException {
    return byteArrayServletOuputStream;
  }

  @Override
  public PrintWriter getWriter() throws IOException {
    return this.printWriter;
  }

  public byte[] toByteArray() throws IOException {
    printWriter.flush();
    byteArrayServletOuputStream.flush();
    return byteArrayServletOuputStream.toByteArray();
  }

  static public class ByteArrayServletOuputStream extends ServletOutputStream {

    private ByteArrayOutputStream output = new ByteArrayOutputStream();

    public ByteArrayServletOuputStream() {
      this.output = new ByteArrayOutputStream();
    }

    @Override
    public void write(int b) throws IOException {
      output.write(b);
    }

    @Override
    public void write(byte[] b, int off, int len) throws IOException {
      super.write(b, off, len);
    }

    @Override
    public void write(byte[] b) throws IOException {
      super.write(b);
    }

    public byte[] toByteArray() {
      return output.toByteArray();
    }

  }
}
