package fr.gouv.finances.dgfip.xemelios.web.utils;

import fr.gouv.finances.dgfip.xemelios.web.*;
import fr.gouv.finances.dgfip.xemelios.web.utils.FilAriane;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.struts.Globals;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

/**
 * @author CBO
 */
public class StdDispatchAction extends DispatchAction {

  protected FilAriane getFilAriane(HttpServletRequest request) {
    return AttributeHelper.getFilAriane(request.getSession());
  }

  protected String getMessage(HttpServletRequest request, String key) {
    return getResources(request).getMessage(getLocale(request), key);
  }

  protected String getMessage(HttpServletRequest request, String key, Object arg) {
    return getResources(request).getMessage(getLocale(request), key, arg);
  }

  protected String getMessage(HttpServletRequest request, String key, Object arg1, Object arg2) {
    return getResources(request).getMessage(getLocale(request), key, arg1, arg1);
  }

  protected String getMessage(HttpServletRequest request, String key, Object args[]) {
    return getResources(request).getMessage(getLocale(request), key, args);
  }
  
  protected  boolean validate(ActionMapping mapping, ActionForm form, HttpServletRequest request) {
    ActionErrors errors = form.validate( mapping, request );

    if ( errors != null && !errors.isEmpty() ) {
        request.getSession().setAttribute(Globals.ERROR_KEY, errors);
        return false;
    }
    else return true;
  }
  
  protected boolean hasFonctionnalite(HttpSession session, String codeFonctionnalite) {
    Principal principal = AttributeHelper.getPrincipal(session);
    return principal != null && principal.getCodesFonctionnalites().contains(codeFonctionnalite);
  }
  
  /**
   * V�rifie que l'utilisateur dispose des bons droits, si ce n'est pas le cas,
   * une exception est lev�e
   * @param session
   * @param codeFonctionnalite code fonctionnalit� � tester
   * @return
   */
  protected void checkFonctionnalite(HttpSession session, String codeFonctionnalite) throws UnauthorizedAccessException {
    if (!hasFonctionnalite(session, codeFonctionnalite))
      throw new UnauthorizedAccessException();
  }
}
