package fr.gouv.finances.dgfip.xemelios.web.utils.filters;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

/**
 * @author CBO
 */
public class AddAuthHeaderForTestFilter implements Filter {

    public void init(FilterConfig filterConfig) throws ServletException {
    }

    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
        if (request instanceof HttpServletRequest) {
            HttpServletRequest httpServletRequest = (HttpServletRequest) request;
            if (httpServletRequest.getAttribute(AddAuthHeaderForTestFilter.class.getName()) == null) {
                AddHeadersResquest addHeadersResquest = new AddHeadersResquest(httpServletRequest);
                String dn = "cn=bosquet,cn=mygroup,ou=people,dc=localdomain:compt";
                addHeadersResquest.addHeader(getAuthHeaderName(), dn);
                request = addHeadersResquest;
            }
        }
        chain.doFilter(request, response);
    }

    public void destroy() {
    }

    private String getAuthHeaderName() {
        return null;
        //return ParametreManager.getAuthHeaderName();
    }

    private class AddHeadersResquest extends HttpServletRequestWrapper {

        private Map<String, String> headers = new HashMap<String, String>();

        public AddHeadersResquest(HttpServletRequest request) {
            super(request);
        }

        public void addHeader(String name, String value) {
            this.headers.put(name, value);
        }

        @Override
        public String getHeader(String name) {
            String value = headers.get(name);
            return value != null ? value : super.getHeader(name);
        }
    }
}
